<script lang="ts">
import { Prop, Component } from 'vue-property-decorator';
import type { Unit, Pixel } from '@/data';
import type SharedActions from '@/logic/SharedActions';
import type { Registerer } from '../LabelBehavior.vue';
import LabelBehavior from '../LabelBehavior.vue';
import type { Emitter } from '../../canvas/canvas-events';

/**
 * Extension of the Registerer type
 *
 * Allows BScrollToLabel to subscribe to the public event 'scroll-to-selection'
 */
type BScrollToRegisterer = Registerer &
((name: 'scroll-to-selection', handler: () => void) => void);

/**
 * Emitter type, to wrap LabelCanvas.$emit
 *
 * Allows any component to emit 'scroll-to-selection' events
 */
export type BScrollToEmitter = Emitter &
((name: 'scroll-to-selection') => void);

/**
 * Scroll on receiving the 'scroll-to-selection' event
 */
@Component
export default class BScrollToLabel extends LabelBehavior<never, BScrollToRegisterer> {
  @Prop()
  actions!: SharedActions;

  @Prop()
  pixelUnit!: Unit<Pixel>;

  @Prop()
  scrollToRange!: (start: Pixel, width: Pixel, smooth: boolean) => void;

  @Prop({ default: 150 })
  margin!: Pixel;

  mounted() {
    // Register the event for CreateOnDrag
    this.register('scroll-to-selection', this.scrollToLabel);
  }

  scrollToLabel() {
    const label = this.actions.getSelected();

    // If label is found, select and scroll to it
    if (label) {
      const range = this.pixelUnit.fromInterval(
        label.onset,
        label.duration,
      );
      this.scrollToRange(
        (range.start - this.margin) as Pixel,
        (range.width + this.margin * 2) as Pixel,
        true,
      );
    }
  }
}
</script>
